#include <iostream>
#include <vector>
#include <cmath>
#include <queue>

#define MAXN 1000
using namespace std;

vector<int> mat[MAXN];
int h[MAXN], n;
char used[MAXN];
queue<int> q;

typedef struct {
        int x, y, r;
} okr;

double len(int x1, int y1, int x2, int y2)
{
       return sqrt((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2));
}

void bfs(int ind)
{
     int t, i, p;
     
     for (i = 0; i < n; ++i) {
         used[i] = 0;
         h[i] = MAXN;
     }
     
     q.push(ind);
     h[ind] = 0;
     
     while (!q.empty()) {
           t = q.front();
           q.pop();
           used[t] = 1;
           for (i = 0; i < mat[t].size(); ++i) {
               p = mat[t][i];
               if (p == n - 1) {
                     printf("%d\n", h[t] + 1);
                     exit(0);
               }
               if (!used[p] && h[p] > h[t] + 1) {
                  h[p] = h[t] + 1;
                  q.push(p);
               }
           }
     }
     
     return;
}                    
     
int main() {
    int i, j, Min, Max;
    double l;
    okr k[MAXN];
    
    scanf("%d", &n);
    
    for (i = 0; i < n; ++i) {
        scanf("%d%d%d", &k[i].x, &k[i].y, &k[i].r);
        for (j = i - 1; j >= 0; --j) {
            l = len(k[i].x, k[i].y, k[j].x, k[j].y);
            Min = min(k[i].r, k[j].r);
            Max = max(k[i].r, k[j].r);
            if ( l < k[i].r + k[j].r && (Min != l || 
               (Min == l && Max < 2*l)) ) {
               mat[i].push_back(j);
               mat[j].push_back(i);
            }
        }
    }
    
    bfs(0);
    
    printf("-1\n");
    
    return 0;
}
