#include <cstdio>
#include <vector>

using namespace std;

struct circle {
	int x;
	int y;
	int r;
	
	circle(){}
	circle(int _x, int _y, int _r) : x(_x), y(_y), r(_r){}
} circles[1024];

vector <int> graph[1024];
int n;
int x, y, r;
bool used[1024];
int uc, l;

int dist(circle a, circle b) {
	return (a.x - b.x)*(a.x - b.x) + (a.y - b.y)*(a.y - b.y);
}

bool good(circle a, circle b) {
	int _dist = dist(a, b);
	return _dist < (a.r + b.r)*(a.r + b.r) && _dist > a.r && _dist > b.r;
}

void make_graph() {
	for(int i = 0; i < n - 1; ++i) {
		for(int j = i + 1; j < n; ++j) {
			if(good(circles[i], circles[j])) {
				graph[i].push_back(j);
				graph[j].push_back(i);
			}
		}
	}
}

int DFS(int x) {
	if(x == n - 1) {
		printf("%d\n", l);
		exit(0);
	}
	else {
		for(int i = 0; i < graph[x].size(); ++i) {
			if(!used[graph[x][i]]) {
				++l;
				used[graph[x][i]] = true;
				DFS(graph[x][i]);
				--l;
				++uc;
			}
		}
	}
}

int main() {
	scanf("%d", &n);
	for(int i = 0; i < n; ++i) {
		scanf("%d%d%d", &x, &y, &r);
		circles[i] = circle(x, y, r);
	}
	
	make_graph();
/*
	printf("%d\n", n);
	for(int i = 0; i < n; ++i) {
		printf("%d %d: ", n, i);
		for(int j = 0; j < graph[i].size(); ++j) {
			printf("%d, ", graph[i][j]);
		}
		printf("\n");
	}
*/
	
	DFS(0);
	
	printf("-1\n");
	
	return 0;
}
