//circle.cpp
#include <stdio.h>
#include <stdlib.h>
#include <queue>
using namespace std;

#define MAX(X, Y) (((X)>(Y))?(X):(Y))
#define MIN(X, Y) (((X)<(Y))?(X):(Y))
#define MAXN 1024

/*
For 2 circles to be connected, let R,r be the
radiuses, D be the distance between the origins.
d - r < R < d + r
1. R + r > d
#########(R + r)^2 > d^2
2. R - r < d
#########(R - r)^2 < d^2
*/

#define D2(I, J) (x[I] - x[J])*(x[I] - x[J]) + (y[I] - y[J])*(y[I] - y[J])

int p[MAXN], n, x[MAXN], y[MAXN], r[MAXN];
bool u[MAXN];
bool conn(int i, int j){
  int d2;
  bool p1, p2;
  d2 = D2(i, j);
  p1 = (r[i] + r[j])*(r[i] + r[j]) > d2;
  p2 = (r[i] - r[j])*(r[i] - r[j]) < d2;
  return p1 && p2;
}

bool bfs(){
  int i, c;
  queue<int> q;
  for(i = 0; i < n; i++)
    u[i] = false;
  q.push(0);
  u[0] = true;
  p[0] = 0;
  while(!q.empty()){
    c = q.front(); q.pop();
    if(c == n - 1) return true;
    for(i = 0; i < n; i++)
      if((!u[i]) && conn(c, i)){
        u[i] = true;
        p[i] = p[c] + 1;
        q.push(i); 
      }
  }
  return false;      
}


int main(){
  int i;
  scanf("%d", &n);
  for(i = 0; i < n; i++)
  scanf("%d %d %d", x + i, y + i, r + i);
  bool ps = bfs();
  if(!ps) printf("-1\n");       
  else printf("%d\n", p[n - 1]);     
  return 0;
}
