//triangle.cpp
/*
+----------------------------------+
| COMPILE WITH GNU-GCC COMPILER!!! |
| ON DEV-C++ 4.9.9.2 OR COMPATIBLE |
+----------------------------------+
*/
#include <stdio.h>
#include <stdlib.h>
#include <ext/hash_map>
//GCC-specific!
using namespace std;
using __gnu_cxx::hash_map;
/*
This program uses hash_map, and the default namespace for
hash_map in GCC is __gnu_cxx.
ON MS VISUAL STUDIO IT WILL BE DIFFERENT, SO:
COMPILE WITH GCC!!!
-------------------
*/
#define MAXN 1024

#define MAX(X, Y) (((X) > (Y))?(X):(Y))
#define paral(X1, Y1, X2, Y2, X3, Y3) (( ((X1) == (X2)) || ((X2) == (X3)) || ((X3) == (X1)) ) || ( ((Y1) == (Y2)) || ((Y2) == (Y3)) || ((Y3) == (Y1)) ))


int n, a[MAXN];
int area2(int ux, int uy, int vx, int vy){
  /*
  The double area of an origin triangle (u, v) is the absolute value of
  ux*vy - vx*uy;
  */    
  int r = ux*vy - vx*uy;
  if(r < 0) r = -r;
  return r;
}

hash_map<int, long long> mem;

/*
encodes i and s in one long long number.
i < n < 1000
s < sum of the area of all triangles < n*(maximal area of a triangle) = 1000*20000 = 20.000.000
s < 20.000.000, so the 100.000.000 coefficient in the multiplication will be ok
*/
long long encode(int i, int s){
  long long res = s;
  res += 100000000ll*i;
  return res;       
}

/*
Memoization solution of the 0-1 knapsack with hashmap container
DP(i, s) - the maximal sum, not over s, which can be done by the first i tringle-areas.

Have 2 options - i is in this sum or not.
*/
int DP(int i, int s){
  int f1, f2;
  long long enc;
  if((s <= 0) || (i < 0)) return 0;
  enc = encode(i, s);
  int p = mem[enc];
  if(p) return p;
  f1 = DP(i-1, s);
  f2 = DP(i-1, s - a[i]) + a[i];
  if(f2 > s) f2 = 0;
  p = MAX(f1, f2);
  mem[enc] = p;
  return p;      
}

int main(){
  int c, i, s, s1;
  int x1, x2, x3, y1, y2, y3, ar;
  bool pr;
  n = 0;
  scanf("%d", &c);
  //Part I: Geometry
  for(i = 0; i < c; i++){
    scanf("%d %d %d %d %d %d", &x1, &y1, &x2, &y2, &x3, &y3);
    pr = paral(x1, y1, x2, y2, x3, y3);
    
    ar = area2( (x2 - x1), (y2 - y1), (x3 - x1), (y3 - y1) );
    //printf("%d|pr: %02d ; ar: %02d\n", i, pr, ar);
    if((!pr) || (ar % 2) || (ar == 0)) continue;
    ar = ar >> 1;
    a[n] = ar;
    n++;
  }
  
  //Part II: MeM - 0-1 knapsack
  s = 0;
  for(i = 0; i < n; i++)
    s += a[i];
  s1=s>>1;
  int res = DP(n-1, s1);
  printf("%d %d\n", res, s - res);  
  return 0;    
}
