#include <cstdio>
#include <queue>
using namespace std;

struct circle {
	int x, y, r;
	
	circle() { }
	circle(int _x, int _y, int _r) : x(_x), y(_y), r(_r) { };
	
	bool intersects(circle& w) {
		int d = (x-w.x)*(x-w.x) + (y-w.y)*(y-w.y);
		return d < (r+w.r)*(r+w.r) &&
				d > (r-w.r)*(r-w.r);
	}
} c[1024];
int n;

struct edge {
	int to, next;
	
	edge() { }
	edge(int _to, int _next) : to(_to), next(_next) { }
} e[1024*1024];
int m, v[1024];
void add_edge(int from, int to) {
	e[m] = edge(to, v[from]);
	v[from] = m;
	++m;
}

queue<int> bfsq[2];
bool used[1024];
int bfs() {
	bfsq[0].push(0);
	used[0] = 1;
	int cv, i, cq = 0, cl = 0;
	while(1) {
		if(bfsq[cq].empty()) {
			cq ^= 1;
			++cl;
			if(bfsq[cq].empty())
				break;
		}
		
		cv = bfsq[cq].front(); bfsq[cq].pop();
		if(cv == n-1) {
			return cl;
		}
		for(i = v[cv]; i != -1; i = e[i].next) {
			if(!used[e[i].to]) {
				bfsq[cq^1].push(e[i].to);
				used[e[i].to] = 1;
			}
		}
	}
	return -1;
}

int main() {
	scanf("%d", &n);
	for(int i = 0; i < n; ++i) {
		v[i] = -1;
		scanf("%d%d%d", &c[i].x, &c[i].y, &c[i].r);
		for(int j = 0; j < i; ++j) {
			if(c[i].intersects(c[j])) {
				add_edge(i, j);
				add_edge(j, i);
			}
		}
	}
	printf("%d\n", bfs());
	return 0;
}
