#include <cstdio>
#include <map>
using namespace std;

#define NL (512*1024)
#define IL 1024*1024

#define SNL (512*1024)
#define SIL 6000

//int index[IL][IL];
map<pair<int, int>, int> index;

int uyi;
inline void updatey(int x, int y, int n) {
	for(uyi = y; uyi < IL; uyi += uyi&(-uyi))
		index[make_pair(x, uyi)] += n;
}
void update(int x, int y, int n) {
	for(int i = x; i < IL; i += i&(-i))
		updatey(i, y, n);
}


inline int queryy(int x, int y) {
	int r = 0;
	for(int i = y; i > 0; i -= i&(-i)) {
		r += index[make_pair(x, i)];
		if(r > 1)
			return 2;
	}
	return r;
}
int queryx(int x, int y) {
	int r = 0;
	for(int i = x; i > 0; i -= i&(-i)) {
		r += queryy(i, y);
		if(r > 1)
			return 2;
	}
	return r;
}
/*int query(int xa, int ya, int xb, int yb) {
	--xa; --ya;
	return queryx(xb, yb) - queryx(xa, yb) - queryx(xb, ya) + queryx(xa, ya);
}*/
void clear() {
	index.clear();
}

int x[NL], y[NL], n;
bool opt[NL];

bool input() {
	scanf("%d", &n);
	int mx = 0, my = 0;
	for(int i = 0; i < n; ++i) {
		scanf("%d%d", x+i, y+i);
		if(x[i] > mx) mx = x[i];
		if(y[i] > my) my = y[i];
		
		x[i] = IL-x[i];
		y[i] = IL-y[i];
	}
	return mx < SIL-1 && my < SIL-1;
}

pair<int, int> big() {
	for(int i = 0; i < n; ++i)
		update(x[i], y[i], 1);
	
	int optn = 0;
	for(int i = 0; i < n; ++i)
		if(queryx(x[i], y[i]) == 1) {
			opt[i] = 1;
			++optn;
		}
	clear();
	for(int i = 0; i < n; ++i)
		if(!opt[i])
			update(x[i], y[i], 1);
	int suboptn = 0;
	for(int i = 0; i < n; ++i)
		if(!opt[i] && queryx(x[i], y[i]) == 1)
			++suboptn;
	return make_pair(optn, suboptn);
}






/**********************************************************/


int sindex[SIL][SIL];

void supdatey(int x, int y, int n) {
	for(int i = y; i < SIL; i += i&(-i))
		sindex[x][i] += n;
}
void supdate(int x, int y, int n) {
	for(int i = x; i < SIL; i += i&(-i))
		supdatey(i, y, n);
}


int squeryy(int x, int y) {
	int r = 0;
	for(int i = y; i > 0; i -= i&(-i))
		r += sindex[x][i];
	return r;
}
int squeryx(int x, int y) {
	int r = 0;
	for(int i = x; i > 0; i -= i&(-i))
		r += squeryy(i, y);
	return r;
}
void sclear() {
	for(int i = 0; i < SIL; ++i)
		for(int j = 0; j < SIL; ++j)
			sindex[i][j] = 0;
}

pair<int, int> small() {
	for(int i = 0; i < n; ++i) {
		x[i] = SIL - (IL - x[i]);
		y[i] = SIL - (IL - y[i]);
	}
	
	for(int i = 0; i < n; ++i) {
		supdate(x[i], y[i], 1);
	}
	int optn = 0;
	for(int i = 0; i < n; ++i)
		if(squeryx(x[i], y[i]) == 1) {
			opt[i] = 1;
			++optn;
		}
	sclear();
	for(int i = 0; i < n; ++i)
		if(!opt[i])
			supdate(x[i], y[i], 1);
	int suboptn = 0;
	for(int i = 0; i < n; ++i)
		if(!opt[i] && squeryx(x[i], y[i]) == 1)
			++suboptn;
	
	return make_pair(optn, suboptn);
}




/**************************************************************/







int main() {
	if(!input()) {
	
		pair<int, int> s = big();
		printf("%d %d\n", s.first, s.second);
	
	} else {
	
		pair<int, int> s = small();
		printf("%d %d\n", s.first, s.second);
		
	}
	return 0;
}
