#include <cstdio>
#include <algorithm>
using namespace std;

struct point {
	int x, y;
	
	point() { }
	point(bool) { scanf("%d%d", &x, &y); }
	point(int _x, int _y) : x(_x), y(_y) { }
	
	bool coll(point &p) {
		return x == p.x || y == p.y;
	}
};

point p[1024][3];
int area[1024];
int n;

inline int abs(int a) {
	return a < 0 ? -a : a;
}

inline int tarea(point& a, point &b, point &c) {
	return a.x*(b.y - c.y) + b.x*(c.y - a.y) + c.x*(a.y - b.y);
}

bool valid(point &a, point &b, point &c, int* area) {
	if((*area = abs(tarea(a, b, c))) % 2) {
		return false;	
	}
	
	if(a.coll(b) || a.coll(c) || b.coll(c)) {
		return true;
	}
	return false;
}

void input() {
	int zn;
	scanf("%d", &zn);
	point a, b, c;
	for(int i = 0; i < zn; ++i) {
		a = point(true);
		b = point(true);
		c = point(true);
		if(valid(a, b, c, &area[n])) {
			p[n][0] = a;
			p[n][1] = b;
			p[n][2] = c;
			++n;
		}
	}
}

int cmp(const void *a, const void *b) {
	return *(int*)b - *(int*)a;
}

int main() {
	input();
	
	qsort(area, n, sizeof(int), cmp);
	
	int s1 = 0, s2 = 0;
	
	for(int i = 0; i < n; ++i)
		if(s1 <= s2)
			s1 += area[i];
		else
			s2 += area[i];
	
	if(s1 < s2)
		printf("%d %d\n", s1/2, s2/2);
	else
		printf("%d %d\n", s2/2, s1/2);
	return 0;
}
